function g1 = dynamic_g1(T, y, x, params, steady_state, it_, T_flag)
% function g1 = dynamic_g1(T, y, x, params, steady_state, it_, T_flag)
%
% File created by Dynare Preprocessor from .mod file
%
% Inputs:
%   T             [#temp variables by 1]     double   vector of temporary terms to be filled by function
%   y             [#dynamic variables by 1]  double   vector of endogenous variables in the order stored
%                                                     in M_.lead_lag_incidence; see the Manual
%   x             [nperiods by M_.exo_nbr]   double   matrix of exogenous variables (in declaration order)
%                                                     for all simulation periods
%   steady_state  [M_.endo_nbr by 1]         double   vector of steady state values
%   params        [M_.param_nbr by 1]        double   vector of parameter values in declaration order
%   it_           scalar                     double   time period for exogenous variables for which
%                                                     to evaluate the model
%   T_flag        boolean                    boolean  flag saying whether or not to calculate temporary terms
%
% Output:
%   g1
%

if T_flag
    T = dw_AF13.dynamic_g1_tt(T, y, x, params, steady_state, it_);
end
g1 = zeros(31, 56);
g1(1,9)=1;
g1(1,12)=(-(params(28)*T(43)*T(44)));
g1(1,14)=(-(params(28)*T(44)*T(46)));
g1(2,10)=1;
g1(2,12)=(-(params(28)*T(43)*T(45)));
g1(2,14)=(-(params(28)*T(45)*T(46)));
g1(3,9)=(-y(14));
g1(3,1)=(-(1-params(30)));
g1(3,11)=1;
g1(3,14)=(-y(9));
g1(4,1)=1-params(30);
g1(4,12)=1;
g1(5,11)=1;
g1(5,13)=1;
g1(6,9)=(-(params(29)/y(37)))/(y(9)*y(9));
g1(6,40)=(-T(38));
g1(6,1)=(-y(31))/(y(1)*y(1));
g1(6,11)=(-((-(T(4)*y(51)*y(42)*2*y(11)))/(T(5)*T(5))));
g1(6,42)=(-(T(4)*y(51)/T(5)));
g1(6,15)=1+y(16);
g1(6,16)=y(15);
g1(6,20)=(-y(33));
g1(6,31)=T(41);
g1(6,51)=(-(T(4)*y(42)/T(5)));
g1(6,33)=(-y(20));
g1(6,37)=(-params(29))/(y(37)*y(37))/y(9)-(T(70)+y(42)*y(51)*T(71)/T(5));
g1(6,53)=(-(T(76)+y(42)*y(51)*T(77)/T(5)));
g1(7,16)=(-1);
g1(7,17)=(-(y(18)/T(6)));
g1(7,43)=T(7)*T(8)/T(9);
g1(7,18)=(-(y(17)/T(6)));
g1(7,44)=T(7)*y(43)*2*y(44)/T(9);
g1(7,24)=(-((-(y(17)*y(18)*T(59)))/(T(6)*T(6))));
g1(7,47)=(-(T(7)*y(43)*T(8)*T(62)))/(T(9)*T(9));
g1(7,26)=1;
g1(7,37)=T(8)*y(43)*T(72)/T(9);
g1(7,53)=T(8)*y(43)*T(78)/T(9);
g1(8,26)=(-((-(params(10)*(1-params(10))))/((params(10)+y(26)*(1-params(10)))*(params(10)+y(26)*(1-params(10))))));
g1(8,27)=1;
g1(9,40)=(-(y(27)*T(10)*T(38)));
g1(9,41)=(-(y(27)*T(3)*T(39)));
g1(9,1)=(-(y(27)*(-((-y(31))/(y(1)*y(1))))));
g1(9,11)=(-((-(T(13)*2*y(11)))/(T(5)*T(5))));
g1(9,42)=(-(T(12)/T(5)));
g1(9,15)=1+y(16)*y(27);
g1(9,16)=y(15)*y(27);
g1(9,20)=(-(y(33)*y(27)));
g1(9,27)=y(15)*y(16)-(T(4)*y(51)*y(42)/T(5)+T(11)+y(27)*T(3)*T(64)-params(3));
g1(9,48)=(-(y(27)*T(3)*T(65)));
g1(9,31)=(-(y(27)*(-T(41))));
g1(9,51)=(-(y(42)*y(53)*params(2)*y(27)/y(37)/T(5)));
g1(9,33)=(-(y(20)*y(27)));
g1(9,37)=(-(y(27)*T(10)*T(70)+y(42)*y(51)*(-(y(53)*params(2)*y(27)))/(y(37)*y(37))/T(5)));
g1(9,53)=(-(y(27)*T(10)*T(76)+y(42)*y(51)*params(2)*y(27)/y(37)/T(5)));
g1(10,1)=(-(T(14)*T(40)*2*T(15)))-T(16)*(exp(T(15)*(-params(20)))*(-params(20))*T(40)+params(20)*T(40));
g1(10,11)=(-(T(14)*2*T(15)*T(41)))-T(16)*(exp(T(15)*(-params(20)))*(-params(20))*T(41)+params(20)*T(41));
g1(10,32)=1;
g1(11,1)=(-((params(19)-1)*T(40)))-T(17)*(-(exp(T(15)*(-params(20)))*(-params(20))*T(40)));
g1(11,11)=(-((params(19)-1)*T(41)))-T(17)*(-(exp(T(15)*(-params(20)))*(-params(20))*T(41)));
g1(11,31)=1;
g1(12,16)=1;
g1(12,18)=(-(T(18)*T(47)*2*T(19)))-T(20)*(exp(T(19)*(-params(15)))*(-params(15))*T(47)+params(15)*T(47));
g1(12,24)=(-(T(18)*2*T(19)*T(60)))-T(20)*(exp(T(19)*(-params(15)))*(-params(15))*T(60)+params(15)*T(60));
g1(13,17)=1;
g1(13,18)=(-((params(14)-1)*T(47)))-T(21)*(-(exp(T(19)*(-params(15)))*(-params(15))*T(47)));
g1(13,24)=(-((params(14)-1)*T(60)))-T(21)*(-(exp(T(19)*(-params(15)))*(-params(15))*T(60)));
g1(14,11)=(-(T(23)*T(42)));
g1(14,19)=1;
g1(14,21)=(-(T(22)*T(53)));
g1(14,38)=(-(T(22)*T(23)));
g1(15,11)=(-((-(y(19)*params(4)))/(y(11)*y(11))));
g1(15,19)=(-(params(4)/y(11)));
g1(15,20)=1;
g1(16,19)=(-(y(33)*(1-params(4))/y(21)));
g1(16,21)=(-((-(y(19)*y(33)*(1-params(4))))/(y(21)*y(21))));
g1(16,22)=1;
g1(16,33)=(-(y(19)*(1-params(4))/y(21)));
g1(17,4)=(-((1-params(5))/params(1)));
g1(17,21)=1;
g1(17,23)=(-1);
g1(18,5)=(-(T(24)*T(54)*2*T(25)))-T(26)*(exp(T(25)*(-params(18)))*(-params(18))*T(54)+params(18)*T(54));
g1(18,23)=(-(T(24)*2*T(25)*T(55)))-T(26)*(exp(T(25)*(-params(18)))*(-params(18))*T(55)+params(18)*T(55));
g1(18,29)=1;
g1(19,5)=(-((params(16)-1)*T(54)))-T(27)*(-(exp(T(25)*(-params(18)))*(-params(18))*T(54)));
g1(19,23)=(-((params(16)-1)*T(55)))-T(27)*(-(exp(T(25)*(-params(18)))*(-params(18))*T(55)));
g1(19,28)=1;
g1(20,5)=(-((-(y(23)*y(28)))/(y(5)*y(5))));
g1(20,23)=(-(y(28)/y(5)-T(29)*T(56)*T(57)));
g1(20,46)=T(29)*T(58);
g1(20,28)=(-(y(23)/y(5)));
g1(20,49)=T(28)*T(30);
g1(20,29)=(-1);
g1(20,30)=1;
g1(20,37)=T(30)*T(73);
g1(20,53)=T(30)*y(49)*params(2)*1/y(37);
g1(21,22)=(-1);
g1(21,30)=1;
g1(21,50)=(-((1-params(5))*T(4)/params(1)));
g1(21,37)=(-((1-params(5))*y(50)*T(71)/params(1)));
g1(21,53)=(-((1-params(5))*y(50)*T(77)/params(1)));
g1(22,11)=y(15)*y(16);
g1(22,15)=y(11)*y(16);
g1(22,16)=y(11)*y(15);
g1(22,19)=(-(1-y(34)));
g1(22,23)=1+y(29);
g1(22,25)=1;
g1(22,29)=y(23);
g1(22,32)=1;
g1(22,34)=y(19);
g1(23,47)=T(63);
g1(23,36)=T(68);
g1(23,37)=1;
g1(23,53)=T(79);
g1(23,39)=(-T(31));
g1(24,25)=(-((-1)/(y(25)*y(25))));
g1(24,37)=1;
g1(25,19)=(-(y(47)*y(52)*(-(T(4)*y(45)))/(y(19)*y(19))));
g1(25,45)=(-(y(47)*y(52)*T(4)/y(19)));
g1(25,24)=y(35);
g1(25,47)=(-(T(4)*y(45)/y(19)*y(52)));
g1(25,33)=(-params(13));
g1(25,34)=(-params(13));
g1(25,35)=y(24);
g1(25,52)=(-(y(47)*T(4)*y(45)/y(19)));
g1(25,37)=(-(y(47)*y(52)*y(45)*T(71)/y(19)));
g1(25,53)=(-(y(47)*y(52)*y(45)*T(77)/y(19)));
g1(26,24)=(-(params(12)/2*2*(y(24)-1)));
g1(26,34)=1;
g1(27,24)=(-params(12));
g1(27,35)=1;
g1(28,2)=(-(y(24)*params(1)*(-y(15))/(y(2)*y(2))));
g1(28,15)=(-(y(24)*params(1)*1/y(2)));
g1(28,18)=1;
g1(28,24)=(-(params(1)*y(15)/y(2)));
g1(29,3)=(-(T(33)*T(50)*T(51)));
g1(29,19)=(-(T(33)*T(51)*T(52)));
g1(29,24)=(-(T(33)*T(51)*T(35)*T(61)));
g1(29,6)=(-(T(37)*T(67)));
g1(29,36)=1;
g1(29,55)=(-(T(37)*T(32)*(-params(25))*exp((-params(25))*x(it_, 2))));
g1(30,7)=(-params(23));
g1(30,38)=1;
g1(30,56)=(-params(24));
g1(31,8)=(-params(26));
g1(31,39)=1;
g1(31,54)=(-params(27));

end
