function T = dynamic_g2_tt(T, y, x, params, steady_state, it_)
% function T = dynamic_g2_tt(T, y, x, params, steady_state, it_)
%
% File created by Dynare Preprocessor from .mod file
%
% Inputs:
%   T             [#temp variables by 1]     double  vector of temporary terms to be filled by function
%   y             [#dynamic variables by 1]  double  vector of endogenous variables in the order stored
%                                                    in M_.lead_lag_incidence; see the Manual
%   x             [nperiods by M_.exo_nbr]   double  matrix of exogenous variables (in declaration order)
%                                                    for all simulation periods
%   steady_state  [M_.endo_nbr by 1]         double  vector of steady state values
%   params        [M_.param_nbr by 1]        double  vector of parameter values in declaration order
%   it_           scalar                     double  time period for exogenous variables for which
%                                                    to evaluate the model
%
% Output:
%   T           [#temp variables by 1]       double  vector of temporary terms
%

assert(length(T) >= 95);

T = dw_AF13.dynamic_g1_tt(T, y, x, params, steady_state, it_);

T(80) = getPowerDeriv(T(1),(-params(9)),2);
T(81) = getPowerDeriv(T(1),1-params(9),2);
T(82) = (-1)/(y(1)*y(1));
T(83) = (-((-((1-params(30))*params(2)*y(53)))*(y(37)+y(37))))/(y(37)*y(37)*y(37)*y(37));
T(84) = params(29)*T(83)/y(53)/y(40);
T(85) = (-((-(params(2)*y(53)))*(y(37)+y(37))))/(y(37)*y(37)*y(37)*y(37));
T(86) = (y(53)*params(29)*(-((1-params(30))*params(2)))/(y(37)*y(37))-params(29)*(-((1-params(30))*params(2)*y(53)))/(y(37)*y(37)))/(y(53)*y(53))/y(40);
T(87) = (-(T(74)*(y(53)+y(53))))/(y(53)*y(53)*y(53)*y(53))/y(40);
T(88) = getPowerDeriv(y(24),params(11),2);
T(89) = (-((-y(11))*(y(1)+y(1))))/(y(1)*y(1)*y(1)*y(1));
T(90) = (-T(59))/(T(6)*T(6));
T(91) = (T(6)*T(6)*(-(y(18)*T(88)))-(-(y(18)*T(59)))*(T(6)*T(59)+T(6)*T(59)))/(T(6)*T(6)*T(6)*T(6));
T(92) = (-((-y(23))*(y(5)+y(5))))/(y(5)*y(5)*y(5)*y(5));
T(93) = (-1)/(y(5)*y(5));
T(94) = getPowerDeriv(y(19)/y(3),params(8),2);
T(95) = getPowerDeriv(T(36),1-params(6),2);

end
