function residual = dynamic_resid(T, y, x, params, steady_state, it_, T_flag)
% function residual = dynamic_resid(T, y, x, params, steady_state, it_, T_flag)
%
% File created by Dynare Preprocessor from .mod file
%
% Inputs:
%   T             [#temp variables by 1]     double   vector of temporary terms to be filled by function
%   y             [#dynamic variables by 1]  double   vector of endogenous variables in the order stored
%                                                     in M_.lead_lag_incidence; see the Manual
%   x             [nperiods by M_.exo_nbr]   double   matrix of exogenous variables (in declaration order)
%                                                     for all simulation periods
%   steady_state  [M_.endo_nbr by 1]         double   vector of steady state values
%   params        [M_.param_nbr by 1]        double   vector of parameter values in declaration order
%   it_           scalar                     double   time period for exogenous variables for which
%                                                     to evaluate the model
%   T_flag        boolean                    boolean  flag saying whether or not to calculate temporary terms
%
% Output:
%   residual
%

if T_flag
    T = dw_AF13.dynamic_resid_tt(T, y, x, params, steady_state, it_);
end
residual = zeros(31, 1);
    residual(1) = (y(9)) - (params(28)*T(1)^(-params(9)));
    residual(2) = (y(10)) - (params(28)*T(1)^(1-params(9)));
    residual(3) = (y(11)) - ((1-params(30))*y(1)+y(9)*y(14));
    residual(4) = (y(12)) - (1-(1-params(30))*y(1));
    residual(5) = (y(13)) - (1-y(11));
    residual(6) = (params(29)/y(37)/y(9)) - (y(33)*y(20)-y(15)*(1+y(16))-y(31)/y(1)+T(3)+T(4)*y(51)*y(42)/T(5));
    residual(7) = (y(26)) - (1+y(16)+y(17)*y(18)/T(6)-T(7)*y(43)*T(8)/T(9));
    residual(8) = (y(27)) - (params(10)/(params(10)+y(26)*(1-params(10))));
    residual(9) = (y(15)*(1+y(16)*y(27))) - (y(27)*T(11)+T(13)/T(5)+(1-y(27))*params(3));
residual(10) = y(32)-T(14)*T(15)^2-T(16)*(exp(T(15)*(-params(20)))+T(15)*params(20)-1);
residual(11) = y(31)-(params(19)-1)*T(15)-T(17)*(1-exp(T(15)*(-params(20))));
residual(12) = y(16)-T(18)*T(19)^2-T(20)*(exp(T(19)*(-params(15)))+T(19)*params(15)-1);
residual(13) = y(17)-(params(14)-1)*T(19)-T(21)*(1-exp(T(19)*(-params(15))));
    residual(14) = (y(19)) - (T(22)*T(23));
    residual(15) = (y(20)) - (y(19)*params(4)/y(11));
    residual(16) = (y(22)) - (y(19)*y(33)*(1-params(4))/y(21));
residual(17) = y(21)-(1-params(5))*y(4)/params(1)-y(23);
residual(18) = y(29)-T(24)*T(25)^2-T(26)*(exp(T(25)*(-params(18)))+T(25)*params(18)-1);
residual(19) = y(28)-(params(16)-1)*T(25)-T(27)*(1-exp(T(25)*(-params(18))));
    residual(20) = (y(30)) - (1+y(29)+y(23)*y(28)/y(5)-T(29)*T(30));
    residual(21) = (y(30)) - (y(22)+T(4)/params(1)*(1-params(5))*y(50));
    residual(22) = (y(23)+y(25)) - (y(19)*(1-y(34))-y(11)*y(15)*y(16)-y(23)*y(29)-y(32));
    residual(23) = (y(37)) - (T(31));
    residual(24) = (y(37)) - (1/y(25));
    residual(25) = (y(24)*y(35)) - (params(13)*(y(33)+y(34))-(params(13)-1)+y(47)*T(4)*y(45)/y(19)*y(52));
    residual(26) = (y(34)) - (params(12)/2*(y(24)-1)^2);
    residual(27) = (y(35)) - (params(12)*(y(24)-1));
    residual(28) = (y(18)) - (y(24)*params(1)*y(15)/y(2));
    residual(29) = (y(36)) - (T(33)*T(37));
    residual(30) = (y(38)) - (params(23)*y(7)+params(24)*x(it_, 3));
    residual(31) = (y(39)) - (params(26)*y(8)+params(27)*x(it_, 1));

end
