function [datingvector statevector] = mbbqinput_model(data,I)

%This program serves to apply the bbq algorithm to a given series

[n V]=size(data);
t=n/I;
datingvector = zeros(size(data));
datingvector(isnan(data)) = NaN;
statevector = zeros(size(data));
statevector(isnan(data)) = NaN;

for i=1:I     % across countries
    time=1+t*(i-1):t*i;
    for v=1:V       % across variables
        if sum(isnan(data(time,v))) < length(data(time,v))-10;
            [datetrough datepeak states] = mbbqSF_model(data(time,v),t);
            statevector(:,v)=states;
            if datetrough ~=0
                datingvector(datetrough+t*(i-1),v) = -1;
            end
            if  datepeak ~=0
                datingvector(datepeak+t*(i-1),v) = 1;
            end
        end
    end
%     datingvector(t*(i-1)+1,:) = zeros(1,V);
%     datingvector(t*i,:) = zeros(1,V);
end