function [s t] = skewTestAC(data)
%function [s t] = skewTestAC(data)
%This function computes the coefficient of skewness (s) of x and gives a standard
%normally distributed test statistic (t) to test that s = 0.
%It follows Bai and Ng (JBES, 2005).
%Author: Alisdair McKay
%Date: 12/4/06
global kernel_;
global white_;


for i = 1:size(data,2)
    x = data(:,i);
    x = x(~isnan(x));
  
    T = size(x,1);
    s(:,i) = skewness(x,0);
    mu = nanmean(x);
    temp = [(x-mu).^3  x-mu];
    %gamma = parzKern(temp)
    [gamma b] = lr_var(temp);
    clear b;
    a = [1 -3*var(x)];
    t(:,i) = s(:,i) * sqrt(T/((a*gamma*a')/(std(x)^6)));
end
