%This script comptutes the skewness in u_(t) - u_(t-k)
clear all;
global time;
clc;
load data/quarterly_SF2.mat;

MRswitch =0;
if MRswitch ==1; filegdp_add=''; else; filegdp_add='pc'; end;
if MRswitch ==1; fileemp_add='emp rate'; else; fileemp_add='employment'; end;

skewCoeffs = -99 * ones(10,5,5);
testStats = -99 * ones(10,5,5);
pVals = -99 * ones(10,5);  %one-sided test
allvarNames = [];
totalskewback= zeros(5,166);
totalskew = zeros(15,166,5);
k_s = [1 2 4 6 8];

country=['US';'EA';'DE';'FR';'UK'];
totda
for m= 1: size(country,1)
	varNames = 'k' ;
    nomcomp = eval(['nomcomp'  country(m,:)]);
    gdpdef  = eval(['gdpdef' country(m,:)]);
    unemp   = eval(['unemp'  country(m,:)]);
    emp     = eval(['emp' country(m,:)]);
    vac     = eval(['vac' country(m,:)]);
    gdp     = eval(['gdp' country(m,:)]);
    invest  = eval(['invest' country(m,:)]);
    pop     = eval(['pop' country(m,:)]);
%    gdpcap  = eval(['gdpcap' country(m,:)]);
    data = [nomcomp gdpdef nomcomp/gdpdef unemp emp vac gdp/pop invest]
    if MRswitch == 1; 
        data = [nomcomp gdpdef nomcomp/gdpdef unemp 1-unemp vac gdp invest]
        x = data; 
    else; 
        x = gdp/pop; end
    
    

    for i = 1:size(k_s,2)
        k = k_s(i);
        for j = 1:6
            %Raw Output: GDP
            
            % growth rates    
            if MRswitch == 1; x = data; else; x = gdp/pop; end
            diff = x(1+k:end,:)./x(1:end-k,:)-1;
            [s t] = skewTestAC(diff);
            skewCoeffs(j,i,m) = s;
            testStats(j,i,m) = t;
            pVals(j,i,m) = pnorm(t);
            if MRswitch ==1; filegdp_add=''; else; filegdp_add='pc'; end;
            if i==1, varNames = strvcat(varNames,[country(m,:) ' raw gdp growth' filegdp_add]); end
        
        j=2 %logs
        if MRswitch == 1; x = log(gdp); else; x = log(gdp/pop); end
        diff = x(1+k:end) - x(1:end-k);
    	
        if k==4, 
            for h=12:length(diff), 
                totalskew(j,h+k,m) = skewness(diff(1:h)); 
                totalskewback(j,end-h+1,m) = skewness(diff(end-h+1:end)); 
            end; 
            for h=40:length(diff), 
                totalskewroll(j,h+k,m) = skewness(diff(h-30+1:h)); 
            end;
        end;

        [s t]             = skewTestAC(diff);
        skewCoeffs(j,i,m) = s;
        testStats(j,i,m)  = t;
        pVals(j,i,m)      = pnorm(t);
        if i==1, varNames = strvcat(varNames,[country(m,:) ' raw gdp log' filegdp_add]); end
    
        %Linear Detrended Output: GDP
        j=3;
        if MRswitch == 1; x = log(gdp); else; x = log(gdp/pop); end;
        x = x - linBreak(x,1973.75,1995.75);
        diff = x(1+k:end) - x(1:end-k);
    
    	if k==4, 
            for h=12:length(diff), 
                totalskew(j,h+k,m) = skewness(diff(1:h)); 
                totalskewback(j,end-h+1,m) = skewness(diff(end-h+1:end)); 
            end; 
            for h=40:length(diff), 
                totalskewroll(j,h+k,m) = skewness(diff(h-30+1:h)); 
            end;
        end;
    
        [s t]             = skewTestAC(diff);
        skewCoeffs(j,i,m) = s;
        testStats(j,i,m)  = t;
        pVals(j,i,m)      = pnorm(t);
        if i==1, varNames = strvcat(varNames,[country(m,:) ' linear gdp ' filegdp_add]); end
    
        %polynomial detrended Output: GDP
        j=4;
        if MRswitch == 1; x = log(gdp); else; x = log(gdp/pop); end;
        x = x - polynomial(x,3);
        diff = x(1+k:end) - x(1:end-k);
    
        if k==4, 
        	for h=12:length(diff), 
                totalskew(j,h+k,m) = skewness(diff(1:h)); 
                totalskewback(j,end-h+1,m) = skewness(diff(end-h+1:end)); 
            end; 
            for h=40:length(diff), 
                totalskewroll(j,h+k,m) = skewness(diff(h-30+1:h)); 
            end;
        end;    
    
        [s t]             = skewTestAC(diff);
        skewCoeffs(j,i,m) = s;
        testStats(j,i,m)  = t;
        pVals(j,i,m)      = pnorm(t);
        if i==1, varNames = strvcat(varNames,[country(m,:) ' polynomial gdp ' filegdp_add]); end
    
        %bandpass Detrended Output: GDP
        j=5;
        if MRswitch == 1; x = log(gdp); else; x = log(gdp/pop); end;
        x = bandpass(x,6,32);
        diff = x(1+k:end) - x(1:end-k);
    
        if k==4, 
        	for h=12:length(diff), 
                totalskew(j,h+k,m) = skewness(diff(1:h)); 
                totalskewback(j,end-h+1,m) = skewness(diff(end-h+1:end)); 
            end; 
            for h=40:length(diff), 
                totalskewroll(j,h+k,m) = skewness(diff(h-30+1:h)); 
            end;
        end;    
    
        [s t]             = skewTestAC(diff);
        skewCoeffs(j,i,m) = s;
        testStats(j,i,m)  = t;
        pVals(j,i,m)      = pnorm(t);
        if i==1, varNames = strvcat(varNames,[country(m,:) ' bandpass(6,32) gdp ' filegdp_add]); end

    
        %Rotemberg Detrended Output: GDP
        j=6;
        if MRswitch == 1; x = log(gdp); else; x = log(gdp/pop); end;
        x = x - rotemberg(x);
        diff = x(1+k:end) - x(1:end-k);

        if k==4, 
            for h=12:length(diff), 
                totalskew(j,h+k,m) = skewness(diff(1:h)); 
                totalskewback(j,end-h+1,m) = skewness(diff(end-h+1:end)); 
            end; 
            for h=40:length(diff), 
                totalskewroll(j,h+k,m) = skewness(diff(h-30+1:h)); 
            end;
        end;

        [s t]             = skewTestAC(diff);
        skewCoeffs(j,i,m) = s;
        testStats(j,i,m)  = t;
        pVals(j,i,m)      = pnorm(t);
        if i==1, varNames = strvcat(varNames,[country(m,:) ' rotemberg gdp ' filegdp_add]); end


        
        %Employment: emp rate
        j=7;
        if MRswitch == 1; x = log(1-unemp/100); else; x = log(emp); end
        diff = x(1+k:end) - x(1:end-k);
        [s t] = skewTestAC(diff);

        if k==4, 
        	for h=12:length(diff), 
                totalskew(j,h+k,m) = skewness(diff(1:h)); 
                totalskewback(j,end-h+1,m) = skewness(diff(end-h+1:end)); 
            end; 
            for h=40:length(diff), 
                totalskewroll(j,h+k,m) = skewness(diff(h-30+1:h)); 
            end;
        end;    
    
        skewCoeffs(j,i,m) = s;
        testStats(j,i,m)  = t;
        pVals(j,i,m)      = pnorm(t);

        if i==1, varNames = strvcat(varNames,[country(m,:) ' raw ' fileemp_add]); end
    
    %Linear Detrended Output: emp rate
        j=7;
        if MRswitch == 1; x = log(1-unemp/100); else; x = log(emp); end
        x= x - linBreak(x,1973.75,1995.75);
%         rhs = horzcat(ones(length(x),1), [1:length(x)]');
%         x = x - rhs*ols(x,rhs);
        diff = x(1+k:end) - x(1:end-k);

        if k==4, 
            for h=12:length(diff), 
                totalskew(j,h+k,m) = skewness(diff(1:h)); 
                totalskewback(j,end-h+1,m) = skewness(diff(end-h+1:end)); 
            end; 
            for h=40:length(diff), 
                totalskewroll(j,h+k,m) = skewness(diff(h-30+1:h)); 
            end;
        end;
    
        [s t] = skewTestAC(diff);
        skewCoeffs(j,i,m) = s;
        testStats(j,i,m) = t;
        pVals(j,i,m) = pnorm(t);
        if i==1, varNames = strvcat(varNames,[country(m,:) ' linear ' fileemp_add]); end
    
        %polynomial Detrended Output: emp rate
        j=8;
        if MRswitch == 1; x = log(1-unemp/100); else; x = log(emp); end
        x = x - polynomial(x,3);
        diff = x(1+k:end) - x(1:end-k);

       if k==4, 
            for h=12:length(diff), 
                totalskew(j,h+k,m) = skewness(diff(1:h)); 
                totalskewback(j,end-h+1,m) = skewness(diff(end-h+1:end)); 
            end; 
            for h=40:length(diff), 
                totalskewroll(j,h+k,m) = skewness(diff(h-30+1:h)); 
            end;
        end;    
    
        [s t] = skewTestAC(diff);
        skewCoeffs(j,i,m) = s;
        testStats(j,i,m) = t;
        pVals(j,i,m) = pnorm(t);
        if i==1, varNames = strvcat(varNames,[country(m,:) ' polynomial ' fileemp_add]); end
    
        %Bandpass Detrended Output: emp rate
        j=9;
        if MRswitch == 1; x = log(1-unemp/100); else; x = log(emp); end
        x = bandpass(x,2,80);
        diff = x(1+k:end) - x(1:end-k);

    	if k==4, 
            for h=12:length(diff), 
                totalskew(j,h+k,m) = skewness(diff(1:h)); 
                totalskewback(j,end-h+1,m) = skewness(diff(end-h+1:end)); 
            end; 
            for h=40:length(diff), 
                totalskewroll(j,h+k,m) = skewness(diff(h-30+1:h)); 
            end;
        end;    
    
        [s t] = skewTestAC(diff);
        skewCoeffs(j,i,m) = s;
        testStats(j,i,m) = t;
        pVals(j,i,m) = pnorm(t);
        if i==1, varNames = strvcat(varNames,[country(m,:) ' bandpass(2,80)' fileemp_add]); end

    
        %Rotemberg Detrended Output: emp rate
        j=10;
        if MRswitch == 1; x = log(1-unemp/100); else; x = log(emp); end
        x = x - rotemberg(x);
        diff = x(1+k:end) - x(1:end-k);
    
    	if k==4, 
            for h=12:length(diff), 
                totalskew(j,h+k,m) = skewness(diff(1:h)); 
                totalskewback(j,end-h+1,m) = skewness(diff(end-h+1:end)); 
            end; 
            for h=40:length(diff), 
                totalskewroll(j,h+k,m) = skewness(diff(h-30+1:h)); 
            end;
        end;
    
        [s t] = skewTestAC(diff);
        skewCoeffs(j,i,m) = s;
        testStats(j,i,m) = t;
        pVals(j,i,m) = pnorm(t);
        if i==1, varNames = strvcat(varNames,[country(m,:) ' rotemberg' fileemp_add]); end

        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        
        %Raw Output: nomcomp rate
        j=11;
        x = log(nomcomp);
        diff = x(1+k:end) - x(1:end-k);
        [s t] = skewTestAC(diff);

       if k==4, 
            for h=12:length(diff), 
                totalskew(j,h+k,m) = skewness(diff(1:h)); 
                totalskewback(j,end-h+1,m) = skewness(diff(end-h+1:end)); 
            end; 
            for h=40:length(diff), 
                totalskewroll(j,h+k,m) = skewness(diff(h-30+1:h)); 
            end;
        end;    
    
        skewCoeffs(j,i,m) = s;
        testStats(j,i,m) = t;
        pVals(j,i,m) = pnorm(t);
        if i==1, varNames = strvcat(varNames,[country(m,:) ' raw nomcomp rate ']); end
    
    %Linear Detrended Output: nomcomp rate
        j=12;
        x = log(nomcomp);
        x= x - linBreak(x,1973.75,1995.75);
%         rhs = horzcat(ones(length(x),1), [1:length(x)]');
%         x = x - rhs*ols(x,rhs);
        diff = x(1+k:end) - x(1:end-k);

        if k==4, 
            for h=12:length(diff), 
                totalskew(j,h+k,m) = skewness(diff(1:h)); 
                totalskewback(j,end-h+1,m) = skewness(diff(end-h+1:end)); 
            end; 
            for h=40:length(diff), 
                totalskewroll(j,h+k,m) = skewness(diff(h-30+1:h)); 
            end;
        end;
    
        [s t] = skewTestAC(diff);
        skewCoeffs(j,i,m) = s;
        testStats(j,i,m) = t;
        pVals(j,i,m) = pnorm(t);
        if i==1, varNames = strvcat(varNames,[country(m,:) ' linear nomcomp rate ']); end
    
        %polynomial Detrended Output: nomcomp rate
        j=13;
        x = log(nomcomp);
        x = x - polynomial(x,3);
        diff = x(1+k:end) - x(1:end-k);

       if k==4, 
            for h=12:length(diff), 
                totalskew(j,h+k,m) = skewness(diff(1:h)); 
                totalskewback(j,end-h+1,m) = skewness(diff(end-h+1:end)); 
            end; 
            for h=40:length(diff), 
                totalskewroll(j,h+k,m) = skewness(diff(h-30+1:h)); 
            end;
        end;    
    
        [s t] = skewTestAC(diff);
        skewCoeffs(j,i,m) = s;
        testStats(j,i,m) = t;
        pVals(j,i,m) = pnorm(t);
        if i==1, varNames = strvcat(varNames,[country(m,:) ' polynomial nomcomp rate ']); end
    
        %Bandpass Detrended Output: nomcomp rate
        j=14;
        x = log(nomcomp);
        x = bandpass(x,2,80);
        diff = x(1+k:end) - x(1:end-k);

    	if k==4, 
            for h=12:length(diff), 
                totalskew(j,h+k,m) = skewness(diff(1:h)); 
                totalskewback(j,end-h+1,m) = skewness(diff(end-h+1:end)); 
            end; 
            for h=40:length(diff), 
                totalskewroll(j,h+k,m) = skewness(diff(h-30+1:h)); 
            end;
        end;    
    
        [s t] = skewTestAC(diff);
        skewCoeffs(j,i,m) = s;
        testStats(j,i,m) = t;
        pVals(j,i,m) = pnorm(t);
        if i==1, varNames = strvcat(varNames,[country(m,:) ' bandpass(2,80) nomcomp rate ']); end

    
        %Rotemberg Detrended Output: nomcomp rate
        j=15;
        x = log(nomcomp);
        x = x - rotemberg(x);
        diff = x(1+k:end) - x(1:end-k);
    
    	if k==4, 
            for h=12:length(diff), 
                totalskew(j,h+k,m) = skewness(diff(1:h)); 
                totalskewback(j,end-h+1,m) = skewness(diff(end-h+1:end)); 
            end; 
            for h=40:length(diff), 
                totalskewroll(j,h+k,m) = skewness(diff(h-30+1:h)); 
            end;
        end;
    
        [s t] = skewTestAC(diff);
        skewCoeffs(j,i,m) = s;
        testStats(j,i,m) = t;
        pVals(j,i,m) = pnorm(t);
        if i==1, varNames = strvcat(varNames,[country(m,:) ' rotemberg nomcomp rate ']); end        
        
        
        
        
        
        
    end

%allvarnames=cat(varNames,3);
    
disp('skewness coefficients');
disp([varNames num2str([k_s; skewCoeffs(:,:,m)])]);

disp(' ');

disp('test stats');    
disp([varNames num2str([k_s; testStats(:,:,m)])]);

disp(' ');

disp('p-values -- one-sided');    
disp([varNames num2str([k_s; pVals(:,:,m)])]);


allvarNames = cat(3,allvarNames,varNames);
end




headerscell= [k_s];

for m=1:length(country)
    labelscell = mat2cell(allvarNames([2,4:7,9:12,14:end],:,m),ones(size(varNames([2,4:7,9:12,14:end],:),1),1),size(varNames([2,4:7,9:12,14:end],:),2));
    output = skewCoeffs([1,3:6,8:11,13:end],:,m);
    
    matrix2SWP(output, [country(m,:) filegdp_add '_skew.tex'], 'rowLabels', labelscell, 'columnLabels', headerscell, 'alignment', 'r', 'format', '%-6.4f')
    output = testStats([1,3:6,8:11,13:end],:,m);
    matrix2SWP(output, [country(m,:) filegdp_add '_tstat.tex'], 'rowLabels', labelscell, 'columnLabels', headerscell, 'alignment', 'r', 'format', '%-6.4f')
    output = pVals([1,3:6,8:11,13:end],:,m);
    matrix2SWP(output, [country(m,:) filegdp_add '_pval.tex'], 'rowLabels', labelscell, 'columnLabels', headerscell, 'alignment', 'r', 'format', '%-6.4f')
end

% varlabel3=[];
% varlabel = varNames(2:end,:);
%     for j=1:10
%         outputtable(3*(j-1)+1,:) = skewCoeffs(j,:,1);
%         outputtable(3*(j-1)+2,:) = testStats(j,:,1);
%         outputtable(3*(j-1)+3,:) = pVals(j,:,1);        
%         varlabel3 =  strvcat(varlabel3,varlabel(j,:));
%         varlabel3 =  strvcat(varlabel3,'t-stat');
%         varlabel3 =  strvcat(varlabel3,'p-val');
%     end
% labelscell  = mat2cell(varlabel3,ones(size(varlabel3,1),1),size(varlabel3,2));
% headerscell = [k_s];
% matrix2SWP(outputtable, ['test.tex'], 'rowLabels', labelscell, 'columnLabels', headerscell, 'alignment', 'r', 'format', '%-6.4f')



for m = 1:length(country)
    subplot(5,2,1+(m-1)*2)
    plot(...
        time(1:end),totalskewroll(1,1:end,m)',...
        time(1:end),totalskewroll(3,1:end,m)',...
        time(1:end),totalskewroll(4,1:end,m)',...
        time(1:end),totalskewroll(5,1:end,m)');
    hold on
    plot([time(1) time(166)],[0 0],'k')
    hold off    
    if m==1; title('GDP per capita'); end;
    
    ylabel(country(m,:))    
    
	subplot(5,2,2+(m-1)*2)
    plot(...
        time(1:end),totalskewroll(6,1:end,m)',...
        time(1:end),totalskewroll(8,1:end,m)',...
        time(1:end),totalskewroll(9,1:end,m)',...
        time(1:end),totalskewroll(10,1:end,m)');
    hold on
    plot([time(1) time(166)],[0 0],'k')
    hold off    
    if m==1; title('Employment'); end;

%     subplot(5,3,3+(m-1)*3)
%     plot(...
%         time(1:end),totalskewroll(11,1:end,m)',...
%         time(1:end),totalskewroll(13,1:end,m)',...
%         time(1:end),totalskewroll(14,1:end,m)',...
%         time(1:end),totalskewroll(15,1:end,m)');
%     hold on
%     plot([time(1) time(166)],[0 0],'k')
%     hold off   
%     if m==1; title('Nominal compensation'); end;       
end
    legend(strvcat('raw','polynomial','bandpass','rotemberg'))

figure

for m = 1:length(country)
    subplot(5,2,1+(m-1)*2)
    plot(...
        time(12+4+1:166),totalskew(1,12+4+1:166,m)',...
        time(12+4+1:166),totalskew(3,12+4+1:166,m)',...
        time(12+4+1:166),totalskew(4,12+4+1:166,m)',...
        time(12+4+1:166),totalskew(5,12+4+1:166,m)');
    hold on
    plot([time(13) time(162)],[0 0],'k')
    hold off
    if m==1; title('GDP per capita'); end;

    ylabel(country(m,:))
    
    
	subplot(5,2,2+(m-1)*2)
    plot(...
        time(12+4+1:166),totalskew(6,12+4+1:166,m)',...
        time(12+4+1:166),totalskew(8,12+4+1:166,m)',...
        time(12+4+1:166),totalskew(9,12+4+1:166,m)',...
        time(12+4+1:166),totalskew(10,12+4+1:166,m)');
    hold on
    plot([time(13) time(162)],[0 0],'k')
    hold off
    if m==1; title('Employment'); end;

%     subplot(5,3,3+(m-1)*3)
%     plot(...
%         time(12+4+1:166),totalskew(11,12+4+1:166,m)',...
%         time(12+4+1:166),totalskew(13,12+4+1:166,m)',...
%         time(12+4+1:166),totalskew(14,12+4+1:166,m)',...
%         time(12+4+1:166),totalskew(15,12+4+1:166,m)');
%     hold on
%     plot([time(13) time(162)],[0 0],'k')
%     hold off
%     if m==1; title('Nominal compensation'); end;    
end
    legend(strvcat('raw','polynomial','bandpass','rotemberg'))